unit frmlogin;
{$MODE ObjFPC}
{$H+}

interface

uses js, web, Classes, frmBase;

type
  
  { --------------------------------------------------------------------
    TLoginForm
    --------------------------------------------------------------------}
  
  { TLoginForm }

  TLoginForm = class(TBaseForm)
  private
    procedure DoLoginClick(Event: TJSEvent);
    procedure DoLoginFailed(Sender: TObject);
    procedure DoLoginOK(Sender: TObject);
  Published
    edtEmail : TJSHTMLInputElement;
    edtPassword : TJSHTMLInputElement;
    btnDoLogin : TJSHTMLButtonElement;
  Public
    constructor create(aOwner : TComponent); override;
    procedure BindElements;
    procedure BindElementEvents;
  end;

implementation

uses webrouter, bulmawidgets, dmServer, frmIndex;

{ --------------------------------------------------------------------
  TLoginForm
  --------------------------------------------------------------------}

           
procedure TLoginForm.DoLoginClick(Event: TJSEvent);

begin
  server.DoLogin(edtEmail.Value,edtPassword.value)
end;

procedure TLoginForm.DoLoginFailed(Sender: TObject);
begin
  Toasts.ShowToast('Login failed','Invalid username/password combination',cDanger,True,-1);
end;

procedure TLoginForm.DoLoginOK(Sender: TObject);
begin
  Toasts.ShowToast('Login OK','Hello, '+Server.UserInfo.Login,cSuccess,true,10);
  IndexForm.mnuUser.classList.remove('is-hidden');
  IndexForm.lblUser.InnerText:=Server.UserInfo.Login;
  IndexForm.mnuLogin.classList.add('is-hidden');
  IndexForm.mnuLogout.classList.remove('is-hidden');
  Router.RouteRequest('/articles',True);
end;

constructor TLoginForm.create(aOwner : TComponent);

begin
  inherited;
  BindElements;
  BindElementEvents;
  Server.OnInvalidLogin:=@DoLoginFailed;
  Server.OnLogin:=@DoLoginOK;
end;



procedure TLoginForm.BindElements;

begin
  edtEmail:=TJSHTMLInputElement(document.getelementByID('edtEmail'));
  edtPassword:=TJSHTMLInputElement(document.getelementByID('edtPassword'));
  btnDoLogin:=TJSHTMLButtonElement(document.getelementByID('btnDoLogin'));
end;


procedure TLoginForm.BindElementEvents;

begin
  btnDoLogin.AddEventListener('click', @DoLoginClick);
end;

end.
